
> module Abstract where

> data SMLNG                   = Tag [Tag] [SMLNG]
>                              | Text String
>                              deriving Eq
>
> type SMLNGs                  = [SMLNG]
> type Tags                    = [Tag]
>
> data Tag                     = TB
>                              | TEM
>                              | TI
>                              | TPL
>                              | TS
>                              | TTT
>                              | TU
>                              | Tsize Int
>                              | Tcolor Color
>                              deriving Eq
>
> data Color                   = Cr | Cg | Cb | Cc | Cm | Cy | Ck | Cw | Cdef
>                              deriving Eq